org.apache.jmeter.gui.menu

## Class StaticJMeterGUIComponent

- java.lang.Object
- - org.apache.jmeter.gui.menu.StaticJMeterGUIComponent

- All Implemented Interfaces:
    ClearGui, JMeterGUIComponent

      @API(since="5.3",
           status=INTERNAL)
      public class StaticJMeterGUIComponent
      extends Object
      implements JMeterGUIComponent

  Internal class to speedup the startup time.

  JMeter needs component names to create menus, however, default GUIComponent implementations create UI elements in their constructors. This class implements just the minimal subset of the methods to make menu factory happy.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StaticJMeterGUIComponent(Class<?> c, TestElementMetadata metadata)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearGui()` Clear the gui and return it to initial default values.
    `void` | `configure(TestElement element)` The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data.
    `JPopupMenu` | `createPopupMenu()` When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
    `TestElement` | `createTestElement()` JMeter test components are separated into a model and a GUI representation.
    `String` | `getDocAnchor()` Get the component's document anchor name.
    `String` | `getLabelResource()` Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language.
    `Collection<String>` | `getMenuCategories()` This is the list of add menu categories this gui component will be available under.
    `String` | `getName()` Gets the name of the JMeter GUI component.
    `String` | `getStaticLabel()` Get the component's label.
    `boolean` | `isEnabled()` Test GUI elements can be disabled, in which case they do not become part of the test when run.
    `void` | `modifyTestElement(TestElement element)` GUI components are responsible for populating TestElements they create with the data currently held in the GUI components.
    `void` | `setEnabled(boolean enabled)` Set whether this component is enabled.
    `void` | `setName(String name)` Sets the name of the JMeter GUI Component.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.jmeter.gui.JMeterGUIComponent

      `canBeAdded`

- - ### Constructor Detail

    - #### StaticJMeterGUIComponent

          public StaticJMeterGUIComponent(Class<?> c,
                                          TestElementMetadata metadata)

  - ### Method Detail

    - #### getLabelResource

          public String getLabelResource()

      Description copied from interface: `JMeterGUIComponent`
      Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language. The resource name is fixed, and does not vary with the selected language. Normally this method should be overridden in preference to overriding getStaticLabel(). However where the resource name is not available or required, getStaticLabel() may be overridden instead.
      Specified by:
        `getLabelResource` in interface `JMeterGUIComponent`
      Returns:
        the resource name

    - #### getStaticLabel

          public String getStaticLabel()

      Description copied from interface: `JMeterGUIComponent`
      Get the component's label. This label is used in drop down lists that give the user the option of choosing one type of component in a list of many. It should therefore be a descriptive name for the end user to see. It must be unique to the class. It is also used by Help to find the appropriate location in the documentation. Normally getLabelResource() should be overridden instead of this method; the definition of this method in AbstractJMeterGuiComponent is intended for general use.
      Specified by:
        `getStaticLabel` in interface `JMeterGUIComponent`
      Returns:
        GUI label for the component.
      See Also:
        `JMeterGUIComponent.getLabelResource()`

    - #### getMenuCategories

          public Collection<String> getMenuCategories()

      Description copied from interface: `JMeterGUIComponent`
      This is the list of add menu categories this gui component will be available under. For instance, if this represents a Controller, then the MenuFactory.CONTROLLERS category should be in the returned collection. When a user right-clicks on a tree element and looks through the "add" menu, which category your GUI component shows up in is determined by which categories are returned by this method. Most GUI's belong to only one category, but it is possible for a component to exist in multiple categories.
      Specified by:
        `getMenuCategories` in interface `JMeterGUIComponent`
      Returns:
        a Collection of Strings, where each element is one of the constants defined in MenuFactory
      See Also:
        `MenuFactory`

    - #### setName

          public void setName(String name)

      Description copied from interface: `JMeterGUIComponent`
      Sets the name of the JMeter GUI Component. The name of the component is used in the Test Tree as the name of the tree node.
      Specified by:
        `setName` in interface `JMeterGUIComponent`
      Parameters:
        `name` - the name of the component

    - #### getName

          public String getName()

      Description copied from interface: `JMeterGUIComponent`
      Gets the name of the JMeter GUI component. The name of the component is used in the Test Tree as the name of the tree node.
      Specified by:
        `getName` in interface `JMeterGUIComponent`
      Returns:
        the name of the component

    - #### getDocAnchor

          public String getDocAnchor()

      Description copied from interface: `JMeterGUIComponent`
      Get the component's document anchor name. Used by Help to find the appropriate location in the documentation
      Specified by:
        `getDocAnchor` in interface `JMeterGUIComponent`
      Returns:
        Document anchor (#ref) for the component.

    - #### createTestElement

          public TestElement createTestElement()

      Description copied from interface: `JMeterGUIComponent`
      JMeter test components are separated into a model and a GUI representation. The model holds the data and the GUI displays it. The GUI class is responsible for knowing how to create and initialize with data the model class that it knows how to display, and this method is called when new test elements are created.

      The canonical implementation looks like this:

           public TestElement createTestElement() {
               TestElementXYZ el = new TestElementXYZ();
               modifyTestElement(el);
               return el;
           }

      Specified by:
        `createTestElement` in interface `JMeterGUIComponent`
      Returns:
        the Test Element object that the GUI component represents.

    - #### modifyTestElement

          public void modifyTestElement(TestElement element)

      Description copied from interface: `JMeterGUIComponent`
      GUI components are responsible for populating TestElements they create with the data currently held in the GUI components. This method should overwrite whatever data is currently in the TestElement as it is called after a user has filled out the form elements in the gui with new information.

      The canonical implementation looks like this:

           public void modifyTestElement(TestElement element) {
               element.clear(); // many implementations use this
               configureTestElement(element);
               // Using the element setters (preferred):
               TestElementXYZ xyz = (TestElementXYZ) element;
               xyz.setState(guiState.getText());
               xyz.setCode(guiCode.getText());
               ... other GUI fields ...
               // or directly (do not use unless there is no setter for the field):
               element.setProperty(TestElementXYZ.STATE, guiState.getText())
               element.setProperty(TestElementXYZ.CODE, guiCode.getText())
               ... other GUI fields ...
           }

      Specified by:
        `modifyTestElement` in interface `JMeterGUIComponent`
      Parameters:
        `element` - the TestElement to modify

    - #### isEnabled

          public boolean isEnabled()

      Description copied from interface: `JMeterGUIComponent`
      Test GUI elements can be disabled, in which case they do not become part of the test when run.
      Specified by:
        `isEnabled` in interface `JMeterGUIComponent`
      Returns:
        true if the element should be part of the test run, false otherwise

    - #### setEnabled

          public void setEnabled(boolean enabled)

      Description copied from interface: `JMeterGUIComponent`
      Set whether this component is enabled.
      Specified by:
        `setEnabled` in interface `JMeterGUIComponent`
      Parameters:
        `enabled` - true for enabled, false for disabled.

    - #### createPopupMenu

          public JPopupMenu createPopupMenu()

      Description copied from interface: `JMeterGUIComponent`
      When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
      Specified by:
        `createPopupMenu` in interface `JMeterGUIComponent`
      Returns:
        a JPopupMenu appropriate for the component.

    - #### configure

          public void configure(TestElement element)

      Description copied from interface: `JMeterGUIComponent`
      The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data. This method is called to allow JMeter to show the user the GUI that represents the test element's data.

      The canonical implementation looks like this:

           public void configure(TestElement element) {
               super.configure(element);
               // Using the element getter (preferred):
               TestElementXYZ xyz = (TestElementXYZ) element;
               guiState.setText(xyz.getState());
               guiCode.setText(xyz.getCode());
               ... other GUI fields ...
               // or using the element property names directly (do not use unless there is no getter for the field)
               guiState.setText(element.getPropertyAsString(TestElementXYZ.STATE));
               guiCode.setText(element.getPropertyAsString(TestElementXYZ.CODE));
               ... other GUI fields ...
           }

      Specified by:
        `configure` in interface `JMeterGUIComponent`
      Parameters:
        `element` - the TestElement to configure

    - #### clearGui

          public void clearGui()

      Description copied from interface: `ClearGui`
      Clear the gui and return it to initial default values. This is necessary because most gui classes are instantiated just once and re-used for multiple test element objects and thus they need to be cleared between uses.
      Specified by:
        `clearGui` in interface `ClearGui`

Copyright © 1998-2019 Apache Software Foundation. All Rights Reserved.